set(POCO_FOUNDATION "POCO_FOUNDATION-NOTFOUND")
set(POCO_DATA "POCO_DATA-NOTFOUND")
set(POCO_MYSQL "POCO_MYSQL-NOTFOUND")
set(POCO_SQLITE "POCO_SQLITE-NOTFOUND")
set(POCO_ODBC "POCO_ODBC-NOTFOUND")

find_path(LIBPOCO_INCLUDE_DIR NAMES Poco/Poco.h
	PATHS
	/usr/include
	/usr/local/include
)

find_library(POCO_FOUNDATION NAMES PocoFoundation
	PATHS
	/usr/lib
	/usr/local/lib
)

find_library(POCO_DATA NAMES PocoData
	PATHS
	/usr/lib
	/usr/local/lib
)

find_library(POCO_MYSQL NAMES PocoMySQL
	PATHS
	/usr/lib
	/usr/local/lib
)

find_library(POCO_SQLITE NAMES PocoSQLite
	PATHS
	/usr/lib
	/usr/local/lib
)

find_library(POCO_ODBC NAMES PocoODBC
	PATHS
	/usr/lib
	/usr/local/lib
)

if(LIBPOCO_INCLUDE_DIR AND POCO_DATA AND POCO_MYSQL AND POCO_FOUNDATION)
	set(LIBPOCO_LIBRARIES ${POCO_DATA} ${POCO_MYSQL} ${POCO_FOUNDATION})
	message(STATUS "Found libPoco: ${LIBPOCO_INCLUDE_DIR}, ${LIBPOCO_LIBRARIES}")
else(LIBPOCO_INCLUDE_DIR AND POCO_DATA AND POCO_MYSQL AND POCO_FOUNDATION)
	message(FATAL_ERROR "libPoco not found.")
endif(LIBPOCO_INCLUDE_DIR AND POCO_DATA AND POCO_MYSQL AND POCO_FOUNDATION)

mark_as_advanced(LIBPOCO_INCLUDE_DIR LIBPOCO_LIBRARIES)

